// original by draw_shida.ppl ( 2017-10-03 15:18:44 ) by akatuki
// https://akatuki-724.blogspot.jp/2017/10/blog-post.html
// port to fx-CG by sentaro21
//
#include "color.h"
#include "display.h"
#include "display_syscalls.h"
#include "keyboard.hpp"
#include "string.h"
#include "keyboard_syscalls.h"
#include "system.h"
#include "stdio.h"
#include "stdlib.h"
#include "disp_tools.hpp"
#include "rtc.h"
#include "CONVERT_syscalls.h"
#include "SYSTEM_syscalls.h"

//--------------------------------------
#define RAND_MAX 65535
unsigned int lastrandom=0x12345678;
unsigned int random( int seed ) {
    if (seed) lastrandom=seed;
    lastrandom = ( 0x41C64E6D*lastrandom ) + 0x3039;
    return ( lastrandom >> 16 );
}

float frand() {
	return (float)random(lastrandom)/(float)(RAND_MAX+1.0);
}

int rgb( int r, int g, int b){	//  r:0~255  g:0~255  b:0~255
	return ((r<<8)&0xF800) + ((g<<3)&0x7E0) + (b>>3);
}
//--------------------------------------

int width =320;
int height=240;
//  initial ooord
float x = 0;
float y = 0;
//  loop counte
int cnt =  30000;
//  working
float tmp = 0;

float xmin = -3.0;
float xmax =  5.0;
float ymin =  0.0;
float ymax =  8.0;

//  functions

//  f1()
void f1()
{
  tmp = 0;
  y = 0.16*y;
  x = tmp;
}

//  f2()
void f2()
{
  tmp = 0.2*x  - 0.26*y;
  y = 0.23*x + 0.22*y + 1.6;
  x = tmp;
}

//  f3()
void f3()
{
  tmp = -0.15*x + 0.28*y;
  y =  0.26*x + 0.24*y + 0.44;
  x = tmp;
}

//  f4()
void f4()
{
  tmp =  0.85*x + 0.04*y;
  y =  -0.04*x + 0.85*y + 1.6;
  x = tmp;
}


//  MAIN 
void main() {
	int key;

	int i,col;
	int xp,yp;
	float r;

	Bdisp_AllClr_VRAM();
     
	for ( i=1; i<cnt; i++ ) {
		r = frand();
    	if ( r < 0.01 )                      { f1(); col = rgb(  0, 0, 0); }
    	if ( ( r >= 0.01 ) && ( r < 0.07 ) ) { f2(); col = rgb(255, 0, 0); }
    	if ( ( r >= 0.07 ) && ( r < 0.15 ) ) { f3(); col = rgb(0, 255, 0); }
    	if ( r >= 0.15 )                     { f4(); col = rgb(0, 0, 255); }
    	xp = (x-xmin)/(xmax-xmin)*width;
    	yp = (y-ymin)/(ymax-ymin)*height;
    	Bdisp_SetPoint_VRAM( yp, xp, col );
    	if ( (i & 0x0000007F) == 0 ) Bdisp_PutDisp_DD();
	}
	while (1) {
        GetKey(&key);
	}
}
